<!-- This file was generated by pybib2web, version 0.6.dev0: https://gitlab.com/sosy-lab/software/pybib2web/ -->
<input type="checkbox" id="show-compact">
<label for="show-compact">Compact view</label>
<h2 id="publications">Publications about CPAcheckerSoftware Model CheckingBAM</h2>
<nav class="publication-navigation">(<a href="../All/index.html">Show all</a> &ndash; <a href="../index.html">Index</a>)</nav>

<a href="../Category/conferences.html"><h3>Articles in conference or workshop proceedings</h3></a>

<ol class="list-publications">

<li class="bibentry" id="ISoLA18b">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span> and
    <span class="author"><a href="../Author/FRIEDBERGER-K.html"><span class="firstname">Karlheinz</span> <span class="lastname">Friedberger</span></a></span>.</span>
    <span class="publication-title">In-Place vs. Copy-on-Write CEGAR Refinement for Block Summarization with Caching.</span>
    <span class="howpublished">
      In <span class="editor-list"><span class="editor"><span class="firstname">T.</span> <span class="lastname">Margaria</span></span> and
      <span class="editor"><span class="firstname">B.</span> <span class="lastname">Steffen</span></span>, editors</span>,
      <em class="booktitle">  Proceedings of the 8th International Symposium on
        Leveraging Applications of Formal Methods, Verification, and Validation
        (ISoLA 2018, Part 2, Limassol, Cyprus, November 5-9)</em>,
      <span class="series">LNCS 11245</span>,
      <span class="pages">pages 197-215</span>,
      <span class="publication-date">  <span class="year">2018</span></span>.
    </span>
    <span class="publisher">Springer.</span>
    <a class="doi" href="https://doi.org/10.1007/978-3-030-03421-4_14" data-doi="10.1007/978-3-030-03421-4_14" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1007/978-3-030-03421-4_14</a>
  </span>
  <a class="bibentry-link" href="#ISoLA18b"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/C.html">C</a>,
        <a class="keyword" href="../Keyword/P.html">P</a>,
        <a class="keyword" href="../Keyword/A.html">A</a>,
        <a class="keyword" href="../Keyword/C.html">c</a>,
        <a class="keyword" href="../Keyword/H.html">h</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/C.html">c</a>,
        <a class="keyword" href="../Keyword/K.html">k</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/R.html">r</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/F.html">f</a>,
        <a class="keyword" href="../Keyword/T.html">t</a>,
        <a class="keyword" href="../Keyword/W.html">w</a>,
        <a class="keyword" href="../Keyword/A.html">a</a>,
        <a class="keyword" href="../Keyword/R.html">r</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/M.html">M</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/D.html">d</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/L.html">l</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/C.html">C</a>,
        <a class="keyword" href="../Keyword/H.html">h</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/C.html">c</a>,
        <a class="keyword" href="../Keyword/K.html">k</a>,
        <a class="keyword" href="../Keyword/I.html">i</a>,
        <a class="keyword" href="../Keyword/N.html">n</a>,
        <a class="keyword" href="../Keyword/G.html">g</a>,
        <a class="keyword" href="../Keyword/B.html">B</a>,
        <a class="keyword" href="../Keyword/A.html">A</a>,
        <a class="keyword" href="../Keyword/M.html">M</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1007/978-3-030-03421-4_14" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2018-ISoLA.In-Place_vs_Copy-on-Write_CEGAR_Refinement_for_Block_Summarization_with_Caching.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
      <a class="presentation-link" href="https://www.sosy-lab.org/research/prs/2018-11-06_ISoLA18_BAM-CoW-Refinement_Dirk.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/presentation.gif">Presentation</a>
      <a class="material-link" href="https://www.sosy-lab.org/research/bam-cow-refinement/"><img alt="" height="15px" width="15px" src="https://www.sosy-lab.org/research/pub/Icons/www.gif">Supplement</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        Block summarization is an efficient technique in software
        verification to decompose a verification problem into separate tasks and
        to avoid repeated exploration of reusable parts of a program. In order to
        benefit from abstraction at the same time, block summarization can be
        combined with counterexample-guided abstraction refinement (CEGAR).
        This causes the following problem: whenever CEGAR instructs the model
        checker to refine the abstraction along a path, several block summaries
        are affected and need to be updated. There exist two different refinement
        strategies: a destructive in-place approach that modifies the existing
        block abstractions and a constructive copy-on-write approach that does
        not change existing data. While the in-place approach is used in the
        field for several years, our new approach of copy-on-write refinement
        has the following important advantage: A complete exportable proof
        of the program is available after the analysis has finished. Due to the
        benefit from avoiding recomputations of missing information as necessary
        for in-place updates, the new approach causes almost no computational
        overhead overall. We perform a large experimental evaluation to compare
        the new approach with the previous one to show that full proofs can be
        achieved without overhead.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{ISoLA18b,
        author = {Dirk Beyer and Karlheinz Friedberger},
        title = {In-Place vs. Copy-on-Write CEGAR Refinement for Block Summarization with Caching},
        booktitle = {Proceedings of the 8th International Symposium on Leveraging Applications of Formal Methods, Verification, and Validation (ISoLA~2018, Part~2, Limassol, Cyprus, November 5-9)},
        editor = {T.~Margaria and B.~Steffen},
        pages = {197-215},
        year = {2018},
        series = {LNCS~11245},
        publisher = {Springer},
        doi = {10.1007/978-3-030-03421-4_14},
        sha256 = {},
        url = {https://www.sosy-lab.org/research/bam-cow-refinement/},
        pdf = {https://www.sosy-lab.org/research/pub/2018-ISoLA.In-Place_vs_Copy-on-Write_CEGAR_Refinement_for_Block_Summarization_with_Caching.pdf},
        presentation = {https://www.sosy-lab.org/research/prs/2018-11-06_ISoLA18_BAM-CoW-Refinement_Dirk.pdf},
        abstract = {Block summarization is an efficient technique in software verification to decompose a verification problem into separate tasks and to avoid repeated exploration of reusable parts of a program. In order to benefit from abstraction at the same time, block summarization can be combined with counterexample-guided abstraction refinement (CEGAR). This causes the following problem: whenever CEGAR instructs the model checker to refine the abstraction along a path, several block summaries are affected and need to be updated. There exist two different refinement strategies: a destructive in-place approach that modifies the existing block abstractions and a constructive copy-on-write approach that does not change existing data. While the in-place approach is used in the field for several years, our new approach of copy-on-write refinement has the following important advantage: A complete exportable proof of the program is available after the analysis has finished. Due to the benefit from avoiding recomputations of missing information as necessary for in-place updates, the new approach causes almost no computational overhead overall. We perform a large experimental evaluation to compare the new approach with the previous one to show that full proofs can be achieved without overhead.},
        keyword = {CPAchecker,Software Model Checking,BAM},
        }
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="ASE18a">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span> and
    <span class="author"><a href="../Author/FRIEDBERGER-K.html"><span class="firstname">Karlheinz</span> <span class="lastname">Friedberger</span></a></span>.</span>
    <span class="publication-title">Domain-Independent Multi-threaded Software Model Checking.</span>
    <span class="howpublished">
      In <span class="editor-list"><span class="editor"><span class="firstname">Marianne</span> <span class="lastname">Huchard</span></span>,
      <span class="editor"><span class="firstname">Christian</span> <span class="lastname">Kästner</span></span>, and
      <span class="editor"><span class="firstname">Gordon</span> <span class="lastname">Fraser</span></span>, editors</span>,
      <em class="booktitle">  Proceedings of the 33rd ACM/IEEE International Conference on Automated
        Software Engineering, ASE 2018, Montpellier, France, September 3-7,
        2018</em>,
      <span class="pages">pages 634-644</span>,
      <span class="publication-date">  <span class="year">2018</span></span>.
    </span>
    <span class="publisher">ACM.</span>
    <a class="doi" href="https://doi.org/10.1145/3238147.3238195" data-doi="10.1145/3238147.3238195" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1145/3238147.3238195</a>
  </span>
  <a class="bibentry-link" href="#ASE18a"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/C.html">C</a>,
        <a class="keyword" href="../Keyword/P.html">P</a>,
        <a class="keyword" href="../Keyword/A.html">A</a>,
        <a class="keyword" href="../Keyword/C.html">c</a>,
        <a class="keyword" href="../Keyword/H.html">h</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/C.html">c</a>,
        <a class="keyword" href="../Keyword/K.html">k</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/R.html">r</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/F.html">f</a>,
        <a class="keyword" href="../Keyword/T.html">t</a>,
        <a class="keyword" href="../Keyword/W.html">w</a>,
        <a class="keyword" href="../Keyword/A.html">a</a>,
        <a class="keyword" href="../Keyword/R.html">r</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/M.html">M</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/D.html">d</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/L.html">l</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/C.html">C</a>,
        <a class="keyword" href="../Keyword/H.html">h</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/C.html">c</a>,
        <a class="keyword" href="../Keyword/K.html">k</a>,
        <a class="keyword" href="../Keyword/I.html">i</a>,
        <a class="keyword" href="../Keyword/N.html">n</a>,
        <a class="keyword" href="../Keyword/G.html">g</a>,
        <a class="keyword" href="../Keyword/B.html">B</a>,
        <a class="keyword" href="../Keyword/A.html">A</a>,
        <a class="keyword" href="../Keyword/M.html">M</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1145/3238147.3238195" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2018-ASE.Domain-Independent_Multi-threaded_Software_Model_Checking.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
      <a class="presentation-link" href="https://www.sosy-lab.org/research/prs/2018-09-07_ASE18_ParallelBAM_Karlheinz.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/presentation.gif">Presentation</a>
      <a class="material-link" href="https://www.sosy-lab.org/research/bam-parallel/"><img alt="" height="15px" width="15px" src="https://www.sosy-lab.org/research/pub/Icons/www.gif">Supplement</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        Recent development of software aims at massively parallel execution,
        because of the trend to increase the number of processing
        units per CPU socket. But many approaches for program analysis
        are not designed to benefit from a multi-threaded execution
        and lack support to utilize multi-core computers. Rewriting existing
        algorithms is difficult and error-prone, and the design of new
        parallel algorithms also has limitations. An orthogonal problem is
        the granularity: computing each successor state in parallel seems
        too fine-grained, so the open question is to find the right structural
        level for parallel execution. We propose an elegant solution to
        these problems: Block summaries should be computed in parallel.
        Many successful approaches to software verification are based on
        summaries of control-flow blocks, large blocks, or function bodies.
        Block-abstraction memoization is a successful domain-independent
        approach for summary-based program analysis. We redesigned the
        verification approach of block-abstraction memoization starting
        from its original recursive definition, such that it can run in a parallel
        manner for utilizing the available computation resources without
        losing its advantages of being independent from a certain abstract
        domain. We present an implementation of our new approach for
        multi-core shared-memory machines. The experimental evaluation
        shows that our summary-based approach has no significant overhead
        compared to the existing sequential approach and that it has
        a significant speedup when using multi-threading.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{ASE18a,
        author = {Dirk Beyer and Karlheinz Friedberger},
        title = {Domain-Independent Multi-threaded Software Model Checking},
        booktitle = {Proceedings of the 33rd {ACM/IEEE} International Conference on Automated Software Engineering, {ASE} 2018, Montpellier, France, September 3-7, 2018},
        editor = {Marianne Huchard and Christian K{\&quot;{a}}stner and Gordon Fraser},
        pages = {634-644},
        year = {2018},
        publisher = {ACM},
        doi = {10.1145/3238147.3238195},
        sha256 = {},
        url = {https://www.sosy-lab.org/research/bam-parallel/},
        pdf = {https://www.sosy-lab.org/research/pub/2018-ASE.Domain-Independent_Multi-threaded_Software_Model_Checking.pdf},
        presentation = {https://www.sosy-lab.org/research/prs/2018-09-07_ASE18_ParallelBAM_Karlheinz.pdf},
        abstract = {Recent development of software aims at massively parallel execution, because of the trend to increase the number of processing units per CPU socket. But many approaches for program analysis are not designed to benefit from a multi-threaded execution and lack support to utilize multi-core computers. Rewriting existing algorithms is difficult and error-prone, and the design of new parallel algorithms also has limitations. An orthogonal problem is the granularity: computing each successor state in parallel seems too fine-grained, so the open question is to find the right structural level for parallel execution. We propose an elegant solution to these problems: Block summaries should be computed in parallel. Many successful approaches to software verification are based on summaries of control-flow blocks, large blocks, or function bodies. Block-abstraction memoization is a successful domain-independent approach for summary-based program analysis. We redesigned the verification approach of block-abstraction memoization starting from its original recursive definition, such that it can run in a parallel manner for utilizing the available computation resources without losing its advantages of being independent from a certain abstract domain. We present an implementation of our new approach for multi-core shared-memory machines. The experimental evaluation shows that our summary-based approach has no significant overhead compared to the existing sequential approach and that it has a significant speedup when using multi-threading.},
        keyword = {CPAchecker,Software Model Checking,BAM},
        }
        
      </div>
    </details>
  </span>
</li>

</ol>
 <section id="disclaimer"> <h4>Disclaimer:</h4> <p class="disclaimer"> This material is presented to ensure timely dissemination of scholarly and technical work. Copyright and all rights therein are retained by authors or by other copyright holders. All person copying this information are expected to adhere to the terms and constraints invoked by each author's copyright. In most cases, these works may not be reposted without the explicit permission of the copyright holder. </p> </section> <footer id="generator">This file was generated by <a href="https://gitlab.com/sosy-lab/software/pybib2web/">pybib2web</a>, version 0.6.dev0</footer>